<?php

error_reporting(E_ERROR);

$_CONFIG["DB_HOST"] =   "localhost";    // Host ของ Database ปกติจะเป็น localhost
$_CONFIG["DB_PORT"] =   3306;           // Port ของ Database ปกติจะเป็น 3306
$_CONFIG["DB_NAME"] =   "";             // ชื่อ Database
$_CONFIG["DB_USER"] =   "";             // ชื่อ Username ของ Database
$_CONFIG["DB_PWD"]  =   "";             // รหัสผ่าน Database

$PaymentObj = new RankPayment(file_get_contents('php://input'), $_CONFIG["DB_HOST"], $_CONFIG["DB_NAME"], $_CONFIG["DB_USER"], $_CONFIG["DB_PWD"], $_CONFIG["DB_PORT"]);

class RankPayment
{
    private $SQLInstance = NULL;
    private $InputBody;
    private $Data;

    function __construct($InputData, $mySqlHost, $mySqlName, $mySqlUser, $mySqlPassWD, $mySqlPort)
    {
        date_default_timezone_set('Asia/Bangkok');

        $this->VerifyAddr();
        $this->InputBody = $InputData;
        $this->VerifyData();
        $this->InitialiseDatabase($mySqlHost, $mySqlName, $mySqlUser, $mySqlPassWD, $mySqlPort);
        $this->Process();
    }

    private function InitialiseDatabase($mySqlHost, $mySqlName, $mySqlUser, $mySqlPassWD, $mySqlPort)
    {
        function InitialiseTable($SQLObject)
        {
            $Query = "
            CREATE TABLE IF NOT EXISTS `rank_payment` (
                `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                `account_id` int(11) UNSIGNED NOT NULL,
                `amount` int(11) UNSIGNED NOT NULL,
                `point` int(11) UNSIGNED NOT NULL,
                `point_bonus` int(11) UNSIGNED NOT NULL,
                `ItemData` varchar(300) DEFAULT NULL,
                `transactionId` varchar(20) NOT NULL,
                `status` tinyint(4) DEFAULT 0 COMMENT '0 = Waiting for server''s script\r\n1 = Successfully Added',
                `created` datetime NOT NULL DEFAULT current_timestamp(),
                PRIMARY KEY (`id`),
                UNIQUE KEY `transactionId` (`transactionId`)
            ) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4;";
            return $SQLObject->query($Query);
        }

        $this->SQLInstance = new mysqli($mySqlHost, $mySqlUser, $mySqlPassWD, $mySqlName, $mySqlPort);

        if (mysqli_connect_errno())
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Error: การเชื่อมต่อ Database ผิดผลาด"));
        }

        if (!InitialiseTable($this->SQLInstance))
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Error: การสร้าง Table ผิดผลาด"));
        }
    }

    private function IsJSON($str)
    {
        json_decode($str);
        return (json_last_error() == JSON_ERROR_NONE);
    }

    private function GetClientAddress()
    {
        function Internal_AddrIsInRange($ip, $range)
        {
            if (strpos($range, '/') == false)
                $range .= '/32';

            list($range, $netmask) = explode('/', $range, 2);
            $range_decimal = ip2long($range);
            $ip_decimal = ip2long($ip);
            $wildcard_decimal = pow(2, (32 - $netmask)) - 1;
            $netmask_decimal = ~$wildcard_decimal;
            return (($ip_decimal & $netmask_decimal) == ($range_decimal & $netmask_decimal));
        }

        function Internal_CfCheckAddr($ip)
        {
            $cf_ips = array(
                '173.245.48.0/20',
                '103.21.244.0/22',
                '103.22.200.0/22',
                '103.31.4.0/22',
                '141.101.64.0/18',
                '108.162.192.0/18',
                '190.93.240.0/20',
                '188.114.96.0/20',
                '197.234.240.0/22',
                '198.41.128.0/17',
                '162.158.0.0/15',
                '104.16.0.0/13',
                '104.24.0.0/14',
                '172.64.0.0/13',
                '131.0.72.0/22',
            );

            $is_cf_ip = false;
            foreach ($cf_ips as $cf_ip)
            {
                if (Internal_AddrIsInRange($ip, $cf_ip))
                {
                    $is_cf_ip = true;
                    break;
                }
            }
            return $is_cf_ip;
        }

        function Internal_CfCheckRequest()
        {
            $flag = true;

            if (!isset($_SERVER['HTTP_CF_CONNECTING_IP']))   $flag = false;
            if (!isset($_SERVER['HTTP_CF_IPCOUNTRY']))       $flag = false;
            if (!isset($_SERVER['HTTP_CF_RAY']))             $flag = false;
            if (!isset($_SERVER['HTTP_CF_VISITOR']))         $flag = false;
            return $flag;
        }

        function IsCloudflare()
        {
            $ipCheck        = Internal_CfCheckAddr($_SERVER['REMOTE_ADDR']);
            $requestCheck   = Internal_CfCheckRequest();
            return ($ipCheck && $requestCheck);
        }

        $check = IsCloudflare();

        if ($check)
        {
            return $_SERVER['HTTP_CF_CONNECTING_IP'];
        }
        else
        {
            return $_SERVER['REMOTE_ADDR'];
        }
    }

    private function VerifyAddr()
    {
        if (md5($this->GetClientAddress()) != "7030eb342ba7f67efac041ae8d3abb23")
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Access denied: Invalid client address."));
        }
    }

    private function VerifyData()
    {
        if (!$this->IsJSON($this->InputBody))
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "Error: ข้อมูลที่ได้รับมาไม่ใช่ JSON"));
        }

        $this->Data = json_decode($this->InputBody, true);
    }

    private function GetAccountID($Username)
    {
        $QueryStmt = "SELECT `account_id` FROM `login` WHERE `userid` = ? LIMIT 1";

        if ($stmt = $this->SQLInstance->prepare($QueryStmt))
        {
            $stmt->bind_param("s", $Username);
            $stmt->execute();
            $result = $stmt->get_result();
            $row = $result->fetch_assoc();

            if ($result->num_rows <= 0)
            {
                return false;
            }

            return $row["account_id"];
        }

        return false;
    }

    private function IsRefExist($refNo)
    {
        if ($stmt = $this->SQLInstance->prepare("SELECT 1 FROM `rank_payment` WHERE `transactionId` = ?"))
        {
            $stmt->bind_param("s", $refNo);
            $stmt->execute();
            $result = $stmt->get_result();

            return (int)$result->num_rows > 0;
        }

        throw new Exception("Could not prepare statement IsRefExist");
    }

    private function InsertData($AccountID, $Amount, $Point, $Bonus, $ItemData, $refNo)
    {
        if ($stmt = $this->SQLInstance->prepare("INSERT INTO `rank_payment`(account_id, amount, point, point_bonus, ItemData, transactionId) VALUES (?, ?, ?, ?, ?, ?)"))
        {
            $stmt->bind_param("iiiiss", $AccountID, $Amount, $Point, $Bonus, $ItemData, $refNo);

            return $stmt->execute();
        }

        throw new Exception("Could not prepare statement InsertData");
    }

    private function Process()
    {
        try
        {
            switch ($this->Data["action"])
            {
                case "CheckServer":
                    $this->ExitWithJSON(array("status" => 0, "message" => "The server is operational."));
                    break;
                case "CheckUser":
                    {
                        if (!array_key_exists("username", $this->Data))
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "The 'username' field is missing in the provided JSON."));
                        }

                        $AccountID = $this->GetAccountID($this->Data["username"]);

                        if ($AccountID === false)
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "ไม่สามารถค้นหาไอดีนี้ได้ โปรดตรวจสอบ"));
                        }

                        $this->ExitWithJSON(array("status" => 0, "message" => "สำเร็จ", "account_id" => $AccountID));
                    }
                    break;
                case "TOPUP":
                    {
                        if (
                            !array_key_exists("GameID", $this->Data) ||
                            !array_key_exists("Amount", $this->Data) ||
                            !array_key_exists("Point", $this->Data) ||
                            !array_key_exists("Bonus", $this->Data) ||
                            !array_key_exists("ItemData", $this->Data) ||
                            !array_key_exists("TransactionID", $this->Data)
                        )
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "ได้รับข้อมูลไม่ครบ โปรดตรวจสอบ"));
                        }

                        if ($this->IsRefExist($this->Data["TransactionID"]))
                        {
                            $this->ExitWithJSON(array("status" => 0, "message" => "มี Transaction นี้อยู่แล้ว การเติมเงินสำเร็จ"));
                        }

                        $AccountID = $this->GetAccountID($this->Data["GameID"]);

                        if ($AccountID === false)
                        {
                            $this->ExitWithJSON(array("status" => 1, "message" => "ไม่สามารถค้นหาไอดีได้หรือไอดีไม่มีอยู่จริงโปรดตรวจสอบ"));
                        }

                        if ($this->InsertData($AccountID, $this->Data["Amount"], $this->Data["Point"], $this->Data["Bonus"], $this->Data["ItemData"], $this->Data["TransactionID"]))
                        {
                            $this->ExitWithJSON(array("status" => 0, "message" => "การเติมเงินสำเร็จ!"));
                        }

                        $this->ExitWithJSON(array("status" => 1, "message" => "การเติมเงินไม่สำเร็จ โปรดติดต่อทีมงาน"));
                    }
                    break;
            }
        }
        catch (Exception $e)
        {
            $this->ExitWithJSON(array("status" => 1, "message" => "ผิดผลาด โปรดติดต่อทีมงาน ข้อความ " . $e->getMessage()));
        }
    }

    private function ExitWithJSON($data)
    {
        header("Content-Type: application/json");
        exit(json_encode($data));
    }
}